<template>
  <div>
    <section v-show="!showForm">
      <button @click="showForm=true" class="btn purple">Wonna add somthing?</button>
    </section>
    <section v-show="showForm">
      <div class="row">
        <div class="col s12">
          <input v-model="qty">
        </div>
        <div class="col s12">
          <label>Select Unit</label>
          <select class="browser-default" v-if="nameSelected" v-model="unitSelected">
            <option v-for="unit in nameSelected.attributes.units" :value="unit">{{unit}}</option>
          </select>
        </div>
      </div>
      <v-select label="name" :filterable="false" :options="options" @search="onSearch" v-model="nameSelected">
        <template slot="no-options">
          type to search available ingredients..
        </template>
        <template slot="option" slot-scope="option">
          <div class="d-center">
            {{ option.attributes.name }}
            </div>
        </template>
        <template slot="selected-option" slot-scope="option">
            {{ option.attributes.name }}
        </template>
      </v-select>

      <button class="btn purple mt-10" @click="addIngredient">
        <i class="fas fa-plus"></i> 
        Add
      </button>
    </section>
  </div>
</template>
<script>
  export default {
    data() {
      return {
        options: [],
        units: [],
        nameSelected: null,
        qty: 1,
        unitSelected: null,
        showForm: false
      }
    },
    methods: {
      onSearch(search, loading) {
        if(search.length > 3) {
          loading(true);
          this.$http.get("/api/v1/all_ingredients", {params: {q: search}}).then(response =>{
            this.options = response.body.data
            loading(false);
          })
        }
      },
      addIngredient() {
        this.$http.post("/api/v1/ingredients", this.params).then(response =>{
          this.options = [],
          this.units = [],
          this.nameSelected = null,
          this.qty = 1,
          this.unitSelected = null
          this.$bus.$emit('ingredientAdded')
          this.showForm = false
          this.notifySuccess("Ingredient successfully added!")
        }, error => {
          this.notifyError("Something went wrong!")
        })
      }
    },
    computed: {
      params() {
        if(this.nameSelected) {
          return {
            ingredient_id: this.nameSelected.id,
            qty: this.qty,
            unit: this.unitSelected
          }
        }
      }
    }
  }
</script>
<style>
</style>
